%{
// $Header: /home/dvermeir/cvsroot/bisonpp/bisonpp/expparser.yy,v 1.1 2002/07/27 10:11:55 dvermeir Exp $

#include	<iostream>
#include	"explexer.h"
#include	"expparser.h"

%}

%union	{
	int	val;
	}

%token NAME  NUMBER LPAREN RPAREN EQUAL PLUS MINUS 
%token TIMES DIVIDE GO

/*	associativity and precedence: in order of increasing precedence */

%nonassoc	EQUAL
%left		PLUS	MINUS
%left		TIMES	DIVIDE
%left		UMINUS	/* dummy token to use as precedence marker */

%type		<val> NUMBER exp

%%
prog		: exp 
			{
			cout << $1 << endl;
			}
		;

exp		: exp PLUS exp
			{
			$$ = $1 + $3;
			}
		| exp MINUS exp
			{
			$$ = $1 - $3;
			}
		| exp TIMES exp
			{
			$$ = $1 * $3;
			}
		| exp DIVIDE exp
			{
			if ($3)
				$$ = $1 / $3;
			}
		| LPAREN exp RPAREN
			{
			$$ = $2;
			}
		| MINUS exp 	%prec UMINUS /* this will force a reduce */
			{
			$$ = -$2;
			}
		| NUMBER
			{
			$$ = $1;
			}
		;
%%

